<?xml version="1.0"?>
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
               xmlns:nest="http://www.xmarker.com"
               version="1.0">

<xsl:output method="xml" indent="yes" encoding="utf-8" />

<xsl:strip-space elements="*" />

<xsl:template match="node()|@*">
 <xsl:copy>
  <xsl:apply-templates select="@*|node()"/>
 </xsl:copy>
</xsl:template>

<xsl:template match="*[local-name()='group']">
 <xsl:element name="{@resname}" 
              xmlns="http://www.xmarker.com">
  <xsl:for-each select="@nest:*">
   <xsl:attribute name="{local-name()}">
    <xsl:value-of select="." />
   </xsl:attribute>
  </xsl:for-each>
  <xsl:apply-templates />
 </xsl:element>
</xsl:template>

<xsl:template match="*[local-name()='mrk' or 
                       local-name()='mrk' or 
                       local-name()='element']">
 <xsl:element name="{substring-after(@mtype,'x-')}" 
              xmlns="http://www.xmarker.com">
  <xsl:for-each select="@nest:*">
   <xsl:attribute name="{local-name()}">
    <xsl:value-of select="." />
   </xsl:attribute>
  </xsl:for-each>
  <xsl:apply-templates />
 </xsl:element>
</xsl:template>

<xsl:template match="*[local-name()='file']">
 <xsl:element name="{@category}" 
              xmlns="http://www.xmarker.com">
  <xsl:for-each select="@nest:*">
   <xsl:attribute name="{local-name()}">
    <xsl:value-of select="." />
   </xsl:attribute>
  </xsl:for-each>
  <xsl:apply-templates />
 </xsl:element>
</xsl:template>

<xsl:template match="*[local-name()='source']" />

<xsl:template match="*[local-name()='target' or 
                       local-name()='body' or
                       local-name()='xliff' or
                       local-name()='trans-unit']">
  <xsl:apply-templates />
</xsl:template>

</xsl:transform>
