<?xml version="1.0"?>
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
               xmlns:xlf="urn:oasis:names:tc:xliff:document:1.1"
               xmlns:nest="http://www.xmarker.com"
               version="1.0">

<xsl:output method="xml" indent="yes" encoding="utf-8" />

<xsl:strip-space elements="*" />

<xsl:template match="node()|@*">
 <xsl:copy>
  <xsl:apply-templates select="@*|node()"/>
 </xsl:copy>
</xsl:template>

<xsl:template match="/" priority="3">
 <xliff xmlns="urn:oasis:names:tc:xliff:document:1.1" 
        xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
        xsi:schemaLocation="urn:oasis:names:tc:xliff:document:1.1 xliff-1.1.xsd" 
        version="1.1" 
        xml:lang="en-us"
        xmlns:nest="http://www.xmarker.com">
  <xsl:apply-templates select="*"/>
 </xliff>
</xsl:template>

<xsl:template match="/*" priority="3">
 <xsl:choose>
  <xsl:when test="text()">
   <file category="{name()}" 
       xmlns="urn:oasis:names:tc:xliff:document:1.1"
       datatype="plaintext" 
       original="my-original-draw-from-config-file" 
       source-language="EN-draw-from-config-file"
       target-language="DE-draw-from-config-file" 
       xml:space="default">
     <body>
      <group>
       <trans-unit>
        <source>
         <xsl:apply-templates select="*"/>
        </source>
       </trans-unit>
      </group>
     </body>
   </file>
  </xsl:when>
  <xsl:otherwise>
   <file category="{name()}" 
       xmlns="urn:oasis:names:tc:xliff:document:1.1"
       datatype="plaintext" 
       original="my-original-draw-from-config-file" 
       source-language="EN-draw-from-config-file"
       target-language="DE-draw-from-config-file" 
       xml:space="default">
     <xsl:for-each select="@*">
      <xsl:attribute name="{concat('nest:',local-name())}">
       <xsl:value-of select="." />
      </xsl:attribute>
     </xsl:for-each>
     <body>
      <xsl:apply-templates select="*"/>
     </body>
   </file>
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

<xsl:template match="*" priority="2">
 <xsl:choose>
  <xsl:when test="text() and *[*]">
   <nest:element id="{concat('nest-',generate-id())}"  mtype="{concat('x-',name())}">
     <xsl:for-each select="@*">
      <xsl:attribute name="{concat('nest:',local-name())}">
       <xsl:value-of select="." />
      </xsl:attribute>
     </xsl:for-each>
     <xsl:apply-templates />
   </nest:element>
  </xsl:when>
  <xsl:when test="text() and *">
   <group id="{concat('one',generate-id())}" resname="{name()}" xml:space="default" xmlns="urn:oasis:names:tc:xliff:document:1.1">
     <xsl:for-each select="@*">
      <xsl:attribute name="{concat('nest:',local-name())}">
       <xsl:value-of select="." />
      </xsl:attribute>
     </xsl:for-each>
    <trans-unit id="{generate-id()}" xmlns="urn:oasis:names:tc:xliff:document:1.1">
     <source xmlns="urn:oasis:names:tc:xliff:document:1.1">
      <xsl:apply-templates />
     </source>
     <target xmlns="urn:oasis:names:tc:xliff:document:1.1">
      <xsl:apply-templates />
     </target>
    </trans-unit>
   </group>
  </xsl:when>
  <xsl:when test="not(text()) and *[text()]">
   <group id="{concat('two',generate-id())}" resname="{name()}" xml:space="default" xmlns="urn:oasis:names:tc:xliff:document:1.1">
     <xsl:for-each select="@*">
      <xsl:attribute name="{concat('nest:',local-name())}">
       <xsl:value-of select="." />
      </xsl:attribute>
     </xsl:for-each>
     <xsl:apply-templates />
   </group>
  </xsl:when>
  <xsl:when test="not(text()) and *">
   <group id="{concat('three',generate-id())}" resname="{name()}" xml:space="default" xmlns="urn:oasis:names:tc:xliff:document:1.1">
     <xsl:for-each select="@*">
      <xsl:attribute name="{concat('nest:',local-name())}">
       <xsl:value-of select="." />
      </xsl:attribute>
     </xsl:for-each>
    <xsl:apply-templates />
   </group>
  </xsl:when>
<!-- 1 -->
  <xsl:when test="text() and not(*) and preceding-sibling::text()">
   <mrk id="{generate-id()}"  mtype="{concat('x-',name())}" xmlns="urn:oasis:names:tc:xliff:document:1.1">
     <xsl:for-each select="@*">
      <xsl:attribute name="{concat('nest:',local-name())}">
       <xsl:value-of select="." />
      </xsl:attribute>
     </xsl:for-each>
      <xsl:apply-templates />
   </mrk>
  </xsl:when>
<!-- 2 -->
  <xsl:when test="text() and not(*) and following-sibling::text()">
   <mrk mtype="{concat('x-',name())}" xmlns="urn:oasis:names:tc:xliff:document:1.1">
     <xsl:for-each select="@*">
      <xsl:attribute name="{concat('nest:',local-name())}">
       <xsl:value-of select="." />
      </xsl:attribute>
     </xsl:for-each>
      <xsl:apply-templates />
   </mrk>
  </xsl:when>
<!-- 3 -->

<!-- 4 
  <xsl:when test="text() and not(*) and following-sibling::text() and following-sibling::*">
   <mrk mtype="{concat('x-',name())}" xmlns="urn:oasis:names:tc:xliff:document:1.1">
     <xsl:for-each select="@*">
      <xsl:attribute name="{concat('nest:',local-name())}">
       <xsl:value-of select="." />
      </xsl:attribute>
     </xsl:for-each>
      <xsl:apply-templates />
   </mrk>
  </xsl:when>

clear up this other stuff as well

  <xsl:when test="text() and not(*) and 
                             preceding-sibling::text() and 
                             not(preceding-sibling::*) and
                             not(following-sibling::*)">
   <mrk-goo id="{generate-id()}"  mtype="{concat('x-',name())}" xmlns="urn:oasis:names:tc:xliff:document:1.1">
      <xsl:apply-templates />
   </mrk-goo>
  </xsl:when>

  <xsl:when test="text() and not(*) and 
                             following-sibling::text() and 
                             not(preceding-sibling::*) and
                             not(following-sibling::*)">
   <mrk-ggoo mtype="{concat('x-',name())}" xmlns="urn:oasis:names:tc:xliff:document:1.1">
      <xsl:apply-templates />
   </mrk-ggoo>
  </xsl:when>
-->
  <xsl:when test="text() and not(*)">
   <group  id="{concat('four',generate-id())}" resname="{name()}" xml:space="default" xmlns="urn:oasis:names:tc:xliff:document:1.1">
     <xsl:for-each select="@*">
      <xsl:attribute name="{concat('nest:',local-name())}">
       <xsl:value-of select="." />
      </xsl:attribute>
     </xsl:for-each>
    <trans-unit id="{concat('tu-four',generate-id())}" xmlns="urn:oasis:names:tc:xliff:document:1.1">
     <source xmlns="urn:oasis:names:tc:xliff:document:1.1">
      <xsl:apply-templates />
     </source>
     <target xmlns="urn:oasis:names:tc:xliff:document:1.1">
      <xsl:apply-templates />
     </target>
    </trans-unit>
   </group>
  </xsl:when>

  <xsl:otherwise>
   <xsl:choose>
    <xsl:when test="preceding-sibling::text() or following-sibling::text()">
     <x id="{concat('one',generate-id())}"  mtype="{concat('x-',name())}" xmlns="urn:oasis:names:tc:xliff:document:1.1">
     <xsl:for-each select="@*">
      <xsl:attribute name="{concat('nest:',local-name())}">
       <xsl:value-of select="." />
      </xsl:attribute>
     </xsl:for-each>
      <xsl:apply-templates />
     </x>
    </xsl:when>
    <xsl:otherwise>
     <group  id="{concat('five',generate-id())}" resname="{name()}" xml:space="default" xmlns="urn:oasis:names:tc:xliff:document:1.1">
      <xsl:for-each select="@*">
       <xsl:attribute name="{concat('nest:',local-name())}">
        <xsl:value-of select="." />
       </xsl:attribute>
      </xsl:for-each>
      <trans-unit id="{generate-id()}" xmlns="urn:oasis:names:tc:xliff:document:1.1">
       <source>
        <x id="{generate-id()}"  mtype="{concat('x-',name())}" xmlns="urn:oasis:names:tc:xliff:document:1.1">
         <xsl:apply-templates />
        </x>
       </source>
      </trans-unit>
     </group>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:otherwise>
 </xsl:choose>
</xsl:template>

</xsl:transform>
